/*******************************************************************************
 *     ___                  _   ____  ____
 *    / _ \ _   _  ___  ___| |_|  _ \| __ )
 *   | | | | | | |/ _ \/ __| __| | | |  _ \
 *   | |_| | |_| |  __/\__ \ |_| |_| | |_) |
 *    \__\_\\__,_|\___||___/\__|____/|____/
 *
 *  Copyright (c) 2014-2019 Appsicle
 *  Copyright (c) 2019-2020 QuestDB
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 ******************************************************************************/

package io.questdb.griffin;

import io.questdb.griffin.model.ExpressionNode;
import io.questdb.std.LongList;
import io.questdb.std.microtime.DateFormatUtils;
import io.questdb.std.str.StringSink;

public class GriffinParserTestUtils {
    private static final StringSink sink = new StringSink();

    public static CharSequence intervalToString(LongList intervals) {
        sink.clear();
        sink.put('[');
        for (int i = 0, n = intervals.size(); i < n; i += 2) {
            if (i > 0) {
                sink.put(',');
            }
            sink.put('{');
            sink.put("lo=");
            DateFormatUtils.appendDateTimeUSec(sink, intervals.getQuick(i));
            sink.put(", ");
            sink.put("hi=");
            DateFormatUtils.appendDateTimeUSec(sink, intervals.getQuick(i + 1));
            sink.put('}');
        }
        sink.put(']');
        return sink;
    }

    public static CharSequence toRpn(ExpressionNode node) {
        sink.clear();
        sink.put(node);
        return sink;
    }

}
